package io.reisub.dreambot.cwintertodt.tasks;

import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.GameObject;

public class Burn extends TaskNode {

    private final WintertodtTask parent;

    public Burn(WintertodtTask parent) {
        this.parent = parent;
    }

    @Override
    public boolean accept() {
        if (!parent.isInterrupted() && !Util.playerIsIdle(1400)) {
            return false;
        }

        return (parent.getRootCount() == 0 && parent.getKindlingCount() > 0) || parent.shouldBurnBeforeRunningOutOfTime();
    }

    @Override
    public int execute() {
        parent.setInterrupted(false);
        parent.setBurning(true);

        if (!Inventory.contains(Constants.BRUMA_ROOT, Constants.BRUMA_KINDLING)) return 0;

        GameObject burningBrazier = GameObjects.closest(Constants.BURNING_BRAZIER);
        GameObject brazier = GameObjects.closest(Constants.BRAZIER);

        if (burningBrazier == null) return 0;

        if (brazier != null && Players.localPlayer().distance(burningBrazier) > Players.localPlayer().distance(brazier)) {
            brazier.interact();

            Util.sleepUntilMovingOrAnimating();

            return Calculations.random(200, 300);
        }

        burningBrazier.interactForceLeft(Constants.FEED);

        Util.sleepUntilMovingAndAnimating();

        return Calculations.random(200, 300);
    }
}
