package io.reisub.dreambot.util.event;

import io.reisub.dreambot.util.event.health.HealthEvent;
import io.reisub.dreambot.util.event.health.HealthListener;

import java.util.EventListener;

public class ListenerManager {
    private static ListenerManager instance;

    private HealthEvent healthEvent;

    public static ListenerManager getInstance() {
        if (instance == null) {
            instance = new ListenerManager();
        }

        return instance;
    }

    private AbstractEvent getEventForListener(EventListener listener) {
        if (listener instanceof HealthListener) {
            if (healthEvent == null) {
                healthEvent = new HealthEvent();
            }
            return healthEvent;
        }

        return null;
    }

    public void addListener(EventListener listener) {
        getEventForListener(listener).addListener(listener);
    }

    public void removeListener(EventListener listener) {
        getEventForListener(listener).removeListener(listener);
    }

    public void removeAllListeners() {
        healthEvent.removeAllListeners();
    }
}
