package io.reisub.dreambot.util.tasks;

import io.reisub.dreambot.util.CInventory;
import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.skills.Skill;
import org.dreambot.api.methods.skills.Skills;
import org.dreambot.api.script.TaskNode;

public class Eat extends TaskNode {
    private final int threshold;

    public Eat(int threshold) {
        this.threshold = threshold;
    }

    public Eat() {
        this(Skills.getRealLevel(Skill.HITPOINTS) / 2);
    }

    @Override
    public boolean accept() {
        return CInventory.hasFood() && Util.getCurrentHP() < threshold;
    }

    @Override
    public int execute() {
        int count = Inventory.count(CInventory.foodItemFilter);

        if (!Inventory.interact(CInventory.foodItemFilter, Constants.EAT)) {
            Inventory.interact(CInventory.foodItemFilter, Constants.DRINK);
        }

        MethodContext.sleepUntil(() -> Inventory.count(CInventory.foodItemFilter) < count, Calculations.random(2000, 2500));

        return 0;
    }
}
